package fr.polytech.ybene.bio.ui;

import fr.polytech.ybene.bio.ColorPosition;
import fr.polytech.ybene.bio.Person;
import fr.polytech.ybene.bio.controller.ColorListener;

import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

public class ParameterDisplay implements PropertyChangeListener {

	// == Attributes ==
	private JButton btnForeground;
	private JButton btnBackground;
	private JButton btnMiddle;
	private JPanel panel1;
	// ================

	// == Constructor ==
	// =================

	// == Getters ==
	public JPanel getPanel1() {
		return panel1;
	}
	// =============

	// == Setters ==
	// =============

	// == Methods ==
	public ParameterDisplay(Person person) {
		ColorListener colorListenerBack = new ColorListener(person, ColorPosition.BACKGROUND);
		colorListenerBack.addPropertyChangeListener(this);
		btnBackground.addActionListener(colorListenerBack);

		ColorListener colorListenerFore = new ColorListener(person, ColorPosition.FOREGROUND);
		colorListenerFore.addPropertyChangeListener(this);
		btnForeground.addActionListener(colorListenerFore);


		ColorListener colorListenerMiddle = new ColorListener(person, ColorPosition.MIDDLE);
		colorListenerMiddle.addPropertyChangeListener(this);
		btnMiddle.addActionListener(colorListenerMiddle);

		Color colorBackground = new Color(person.getBackgroundColor()[0], person.getBackgroundColor()[1],
				person.getBackgroundColor()[2]);
		Color colorForeground = new Color(person.getForegroundColor()[0], person.getForegroundColor()[1],
				person.getForegroundColor()[2]);
		Color colorMiddle = new Color(person.getMiddleColor()[0], person.getMiddleColor()[1],
				person.getMiddleColor()[2]);

		btnBackground.setIcon(createIcon(colorBackground, 16, 16));
		btnForeground.setIcon(createIcon(colorForeground, 16, 16));
		btnMiddle.setIcon(createIcon(colorMiddle, 16, 16));
	}

	public static ImageIcon createIcon(Color main, int width, int height) {
		BufferedImage image = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
		Graphics2D graphics = image.createGraphics();
		graphics.setColor(main);
		graphics.fillRect(0, 0, width, height);
		graphics.setXORMode(Color.DARK_GRAY);
		graphics.drawRect(0, 0, width - 1, height - 1);
		image.flush();
		ImageIcon icon = new ImageIcon(image);
		return icon;
	}

	@Override
	public void propertyChange(PropertyChangeEvent evt) {
		Color color = (Color) evt.getNewValue();
		switch (evt.getPropertyName()) {
			case "FOREGROUND":
				btnForeground.setIcon(createIcon(color, 16, 16));

				break;
			case "BACKGROUND":
				btnBackground.setIcon(createIcon(color, 16, 16));
				break;
			case "MIDDLE":
				btnMiddle.setIcon(createIcon(color, 16, 16));

				break;
			default:
				break;
		}
		panel1.repaint();
		panel1.revalidate();
	}
	// =============

	// == Black magic ==

	{
// GUI initializer generated by IntelliJ IDEA GUI Designer
// >>> IMPORTANT!! <<<
// DO NOT EDIT OR ADD ANY CODE HERE!
		$$$setupUI$$$();
	}

	/**
	 * Method generated by IntelliJ IDEA GUI Designer
	 * >>> IMPORTANT!! <<<
	 * DO NOT edit this method OR call it in your code!
	 *
	 * @noinspection ALL
	 */
	private void $$$setupUI$$$() {
		panel1 = new JPanel();
		panel1.setLayout(new com.intellij.uiDesigner.core.GridLayoutManager(4, 3, new Insets(10, 10, 10, 10), -1, -1));
		btnForeground = new JButton();
		btnForeground.setText("");
		panel1.add(btnForeground, new com.intellij.uiDesigner.core.GridConstraints(1, 2, 1, 1, com.intellij.uiDesigner.core.GridConstraints.ANCHOR_CENTER, com.intellij.uiDesigner.core.GridConstraints.FILL_HORIZONTAL, com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_CAN_SHRINK | com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_CAN_GROW, com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
		btnMiddle = new JButton();
		btnMiddle.setText("");
		panel1.add(btnMiddle, new com.intellij.uiDesigner.core.GridConstraints(2, 2, 1, 1, com.intellij.uiDesigner.core.GridConstraints.ANCHOR_CENTER, com.intellij.uiDesigner.core.GridConstraints.FILL_HORIZONTAL, com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_CAN_SHRINK | com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_CAN_GROW, com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
		btnBackground = new JButton();
		btnBackground.setText("");
		panel1.add(btnBackground, new com.intellij.uiDesigner.core.GridConstraints(3, 2, 1, 1, com.intellij.uiDesigner.core.GridConstraints.ANCHOR_CENTER, com.intellij.uiDesigner.core.GridConstraints.FILL_HORIZONTAL, com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_CAN_SHRINK | com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_CAN_GROW, com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
		final JLabel label1 = new JLabel();
		label1.setText("Foreground :");
		panel1.add(label1, new com.intellij.uiDesigner.core.GridConstraints(1, 1, 1, 1, com.intellij.uiDesigner.core.GridConstraints.ANCHOR_WEST, com.intellij.uiDesigner.core.GridConstraints.FILL_NONE, com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_FIXED, com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
		final JLabel label2 = new JLabel();
		label2.setText("Middle :");
		panel1.add(label2, new com.intellij.uiDesigner.core.GridConstraints(2, 1, 1, 1, com.intellij.uiDesigner.core.GridConstraints.ANCHOR_WEST, com.intellij.uiDesigner.core.GridConstraints.FILL_NONE, com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_FIXED, com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
		final JLabel label3 = new JLabel();
		label3.setText("Background :");
		panel1.add(label3, new com.intellij.uiDesigner.core.GridConstraints(3, 1, 1, 1, com.intellij.uiDesigner.core.GridConstraints.ANCHOR_WEST, com.intellij.uiDesigner.core.GridConstraints.FILL_NONE, com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_FIXED, com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
		final JLabel label4 = new JLabel();
		label4.setText("Color :");
		panel1.add(label4, new com.intellij.uiDesigner.core.GridConstraints(0, 0, 1, 1, com.intellij.uiDesigner.core.GridConstraints.ANCHOR_WEST, com.intellij.uiDesigner.core.GridConstraints.FILL_NONE, com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_FIXED, com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
	}

	/**
	 * @noinspection ALL
	 */
	public JComponent $$$getRootComponent$$$() {
		return panel1;
	}

	// =================
}
